#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"

#include "xsw.h"


int CmdAutoInterval(const char *arg);


#define THIS_CMD_NAME	"autointerval"

#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


int CmdAutoInterval(const char *arg)
{
	if(STRISEMPTY(arg))
	{
	    char *s = (char *)malloc(STRLEN(THIS_CMD_NAME) + 40 + 80);
	    sprintf(
		s,
"%s: %s",
		THIS_CMD_NAME,
		auto_interval_tune.state ? "on" : "off"
	    );
	    XSWPrint(s);
	    free(s);
	}
	else
	{
            char *s = (char *)malloc(STRLEN(THIS_CMD_NAME) + 40 + 80);
	    auto_interval_tune.state = StringIsYes(arg);
	    sprintf(
		s,
"%s: %s",
		THIS_CMD_NAME,
		auto_interval_tune.state ? "on" : "off"
	    );
	    XSWPrint(s);
	    free(s);
	}

	return(0);
}
