#include <stdlib.h>
#include <string.h>
#include "xsw.h"


int CmdDebug(const char *arg);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


int CmdDebug(const char *arg)
{
	char	*s,
		larg[256],
		stringa[256];

	if((arg != NULL) ? (arg[0] == '\0') : 1)
	{
	    sprintf(
		stringa,
"debug level: %i  debug value: %.4f",
		debug.level, debug.val
	    );
	    XSWPrint(stringa);
	    XSWPrint(
"Usage: `debug [level][=<value>]'"
	    );

	    XSWPrint(
"<levels> can be: DEBUG_LEVEL_NONE = 0, DEBUG_LEVEL_ALL = 1\
 DEBUG_LEVEL_MEMORY = 2, DEBUG_LEVEL_NETWORK = 3"
	    );

	    return(0);
	}  
	strncpy(larg, arg, 256);
	larg[255] = '\0';


	s = strchr(larg, '=');
	if(s != NULL)
	    debug.val = atof(s + 1);

	if(s != NULL)
	    *s = '\0';
 
	debug.level = atoi(larg);


	sprintf(
	    stringa,
	    "debug: level %i: value %.4f",
	    debug.level, debug.val
	);
	XSWPrint(stringa);

	return(0);
}
