#include <stdlib.h>
#include <string.h>
#include "net.h"
#include "xsw.h"


int CmdLoginPassword(const char *arg);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)

 
int CmdLoginPassword(const char *arg)
{
	char *s;
	xsw_net_parms_struct *net = &net_parms;

	/* Print current value? */
	if((arg != NULL) ? (*arg == '\0') : True)
	{
	    s = (char *)malloc(
		STRLEN(net->login_password) + 80
	    );
	    sprintf(
		s,
"login_password: `%s'",
		(net->login_password != NULL) ?
		    net->login_password : ""
	    );
	    XSWPrint(s);
	    free(s);
	    return(0);
	}
	 
	/* Set login password */
	free(net->login_password);
	net->login_password = strdup(arg);

	s = (char *)malloc(
	    STRLEN(net->login_password) + 80
	);
	sprintf(
	    s,
	    "login_password: `%s'",
	    (net->login_password != NULL) ?
		net->login_password : ""
	);
	XSWPrint(s);
	free(s);

	return(0);
}
