#ifndef ECOWIN_H
#define ECOWIN_H

#include "../include/osw-x.h"
#include "../include/widget.h"

typedef struct _xsw_eco_win_struct	xsw_eco_win_struct;
#define XSW_ECO_WIN(p)			((xsw_eco_win_struct *)(p))


/*
 *	Economy Window:
 */
struct _xsw_eco_win_struct {

	bool_t		map_state,
			has_focus,
			disabled;
	int		freeze_count,
			busy_count;
	int		x, y;
	unsigned int	width, height;
	visibility_t	visibility_state;

	win_t		toplevel;

	label_struct	credits_name_label,
			credits_value_label,
			taxes_label;

	prompt_struct   proprietor_prompt;

	push_button_struct      refresh_btn;

	clist_struct	inventory;

	prompt_struct	amount_prompt;

	push_button_struct	buy_btn,
				sell_btn,
				close_btn;

	int		proprietor_obj_num;
};


extern "C" void EcoWinUpdateCredits(
	xsw_eco_win_struct *ew,
	const int obj_num
);
extern "C" void EcoWinAddProduct(
	xsw_eco_win_struct *ew,
	const int proprietor_obj_num,
	xsw_ecoproduct_struct product
);
extern "C" void EcoWinClearProducts(xsw_eco_win_struct *ew);

extern "C" xsw_eco_win_struct *EcoWinNew(void);
extern "C" void EcoWinResize(xsw_eco_win_struct *ew);
extern "C" void EcoWinQueueResize(xsw_eco_win_struct *ew);
extern "C" void EcoWinDraw(xsw_eco_win_struct *ew);
extern "C" void EcoWinQueueDraw(xsw_eco_win_struct *ew);
extern "C" int EcoWinManage(xsw_eco_win_struct *ew, event_t *event);
extern "C" void EcoWinMap(xsw_eco_win_struct *ew);
extern "C" void EcoWinUnmap(xsw_eco_win_struct *ew);
extern "C" void EcoWinDelete(xsw_eco_win_struct *ew);


#endif	/* ECOWIN_H */
