#ifndef IGNOREDOBJ_H
#define IGNOREDOBJ_H

#include "../include/objects.h"


typedef struct _ignored_obj_struct	ignored_obj_struct;
#define IGNORED_OBJ(p)		((ignored_obj_struct *)(p))


/*
 *	Ignored Object:
 */
struct _ignored_obj_struct {

	int		obj_num;
	char		name[SW_OBJ_NAME_MAX];

};


extern "C" ignored_obj_struct *IgnoredObjNew(void);
extern "C" void IgnoredObjDelete(ignored_obj_struct *iobj);

extern "C" int IgnoredObjListMatch(
	ignored_obj_struct **list, const int total,
	const int obj_num, const char *name
);

extern "C" int IgnoredObjListAdd(
	ignored_obj_struct ***list, int *total,
	const int obj_num, const char *name
);
extern "C" void IgnoredObjListRemove(
	ignored_obj_struct ***list, int *total,
	const int obj_num, const char *name
);
extern "C" void IgnoredObjListDelete(
	ignored_obj_struct ***list, int *total,
	const int iobj_num
);
extern "C" void IgnoredObjListClear(
	ignored_obj_struct **list, const int total
);


#endif	/* IGNOREDOBJ_H */
