/*
                         Joystick Mapping Window
 */

#ifdef JS_SUPPORT

#ifndef JSMAPWIN_H
#define JSMAPWIN_H

#include "../include/osw-x.h"
#include "../include/widget.h"

typedef struct _xsw_jsmap_win_struct	xsw_jsmap_win_struct;
#define XSW_JSMAP_WIN(p)	((xsw_jsmap_win_struct *)(p))


/*
 *	Draw amount codes:
 */
#define JSMW_DRAW_AMOUNT_COMPLETE	0
#define JSMW_DRAW_AMOUNT_SCANKEY	1


/*
 *	Joystick Map Window:
 */
struct _xsw_jsmap_win_struct {

	bool_t		map_state,
			has_focus,
			disabled;
	int		freeze_count,
			busy_count;
	int		x, y;
	unsigned int	width, height;
	visibility_t	visibility_state;

	win_t		toplevel;


	clist_struct	js_list;

	push_button_struct	add_btn,
				remove_btn;


	prompt_struct	device_prompt;
	push_button_struct	initialize_btn;

	prompt_struct	turn_axis_prompt,
			throttle_axis_prompt,
			thrust_dir_axis_prompt,
			vs_zoom_axis_prompt,
			scanner_zoom_axis_prompt,
			aim_weapon_heading_prompt;

	clist_struct	buttons_list;
	push_button_struct	scan_key_btn;
	bool_t		scanning_key;
	win_t		scan_key_win;

	push_button_struct	ok_btn,
				apply_btn,
				cancel_btn;

};


extern "C" xsw_jsmap_win_struct *JSMWNew(void);
extern "C" void JSMWResize(xsw_jsmap_win_struct *jsmw);
extern "C" void JSMWQueueResize(xsw_jsmap_win_struct *jsmw);
extern "C" void JSMWDraw(xsw_jsmap_win_struct *jsmw, const int amount);
extern "C" void JSMWQueueDraw(xsw_jsmap_win_struct *jsmw, const int amount);
extern "C" int JSMWManage(xsw_jsmap_win_struct *jsmw, event_t *event);
extern "C" void JSMWMap(xsw_jsmap_win_struct *jsmw, win_t toplevel);
extern "C" void JSMWUnmap(xsw_jsmap_win_struct *jsmw);
extern "C" void JSMWDelete(xsw_jsmap_win_struct *jsmw);


#endif	/* JSMAPWIN_H */

#endif	/* JS_SUPPORT */
