#include <stdlib.h>
#include <string.h>

#include "../include/osw-x.h"

#include "keymaps.h"
#include "xsw.h"


int KeymapsGetTotal(void);

keymap_struct *KeymapGetPtr(const int keymap_num);
keycode_t KeymapGetKeycode(const int keymap_num);


keymap_struct keymaps_list[] = KEYMAPS_LIST;


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


/*
 *	Returns the total number of keymaps.
 */
int KeymapsGetTotal(void)
{
	return((int)sizeof(keymaps_list) / (int)sizeof(keymap_struct));
}


/*
 *	Returns the pointer to the specified keymap.
 */
keymap_struct *KeymapGetPtr(const int keymap_num)
{
	const int m = KeymapsGetTotal();

	if((keymap_num < 0) || (keymap_num >= m))
	    return(NULL);

	return(&keymaps_list[keymap_num]);
}

/*
 *	Returns the keycode associated with the specified keymap.
 */
keycode_t KeymapGetKeycode(const int keymap_num)
{
	const int m = KeymapsGetTotal();

	if((keymap_num < 0) || (keymap_num >= m))
	    return(0);

	return(keymaps_list[keymap_num].keycode);
}
