#ifndef MSGLIST_H
#define MSGLIST_H

#include "../include/osw-x.h"
#include "../include/widget.h"


typedef struct _xsw_mesg_struct         xsw_mesg_struct;
#define XSW_MSG(p)			((xsw_mesg_struct *)(p))


#define MSG_LIST_MSG_LEN		111	/* Characters */


/*
 *	Message:
 */
struct _xsw_mesg_struct {

	char		message[MSG_LIST_MSG_LEN];

	unsigned int	flags;		/* Any of XSW_MESG_FLAG_* */

	pixel_t		fg_pix,
			bg_pix;

	int		sel_start,	/* Can be -1 for not selected */
			sel_end;

};


/* msglist.cpp */
extern "C" void MsgListSetSize(const int nmessages);

extern "C" void MsgListAppend(
	const char *s,
	pixel_t fg_pix, pixel_t bg_pix,
	const unsigned int flags
);

extern "C" void MsgListUnmarkAll(void);

extern "C" void MsgListCopyToClipboard(win_t w);

extern "C" void MsgListQueueDrawAllWindows(void);


#endif	/* MSGLIST_H */
