#ifndef SPLASH_H
#define SPLASH_H

#include "../include/osw-x.h"
#include "../include/widget.h"

typedef struct _splash_win_struct	splash_win_struct;
#define SPLASH_WIN(p)			((splash_win_struct *)(p))


/*
 *	Splash Window:
 */
struct _splash_win_struct {

	bool_t		map_state,
			has_focus,
			disabled;
	int		x, y;
	unsigned int	width, height;
	visibility_t	visibility_state;

	win_t		toplevel;
	pixmap_t	toplevel_buf;

	image_t		*bkg_img,
			*pb_l_img,
			*pb_r_img,
			*pb_t_img;

	cursor_t	cursor;
};


extern splash_win_struct *SplashNew(void);
extern void SplashProgress(
	splash_win_struct *sw,
	const float coeff, const char *msg
);
extern void SplashDelete(splash_win_struct *sw);


#endif /* SPLASH_H */
