#ifndef UNIVLIST_H
#define UNIVLIST_H

#include <sys/types.h>
#include "../include/osw-x.h"
#include "../include/widget.h"

typedef struct _unvitem_struct	unvitem_struct;
#define UNVITEM(p)	((unvitem_struct *)(p))


/*
 *	Universe Item:
 */
struct _unvitem_struct {

	char		*alias;		/* Alias (name of this universe) */
	char		*url;		/* URL to this universe */
	time_t		last_connected;	/* In systime seconds */
	char		*comments;
	unsigned int	times_connected;

};


/* unvlist.cpp */
extern "C" unvitem_struct *UnvItemNew(void);
extern "C" void UnvItemDelete(unvitem_struct *item);

extern "C" int UnvListItemIsAllocated(
	unvitem_struct **list, const int total,
	const int item_num
);

extern "C" u_int8_t *UnvItemToData(unvitem_struct *item, int *len_rtn);
extern "C" unvitem_struct *UnvDataToItem(const u_int8_t *data, int len);

extern "C" int UnvListInsert(
	unvitem_struct ***list, int *total_rtn,
	const int item_num,
	const char *alias,
	const char *url,
	const time_t last_connected,
	const char *comments
);
extern "C" int UnvListAppend(
	unvitem_struct ***list, int *total_rtn,
	const char *alias,
	const char *url,
	const time_t last_connected,
	const char *comments
);
extern "C" void UnvListClear(unvitem_struct **list, const int total);


#endif	/* UNIVLIST_H */
