#ifndef UNIVLISTWIN_H
#define UNIVLISTWIN_H

#include "../include/osw-x.h"
#include "../include/widget.h"
#include "unvlist.h"

typedef struct _xsw_unvlist_win_struct	xsw_unvlist_win_struct;
#define XSW_UNVLIST_WIN(p)	((xsw_unvlist_win_struct *)(p))


/*
 *	Universe list window redraw codes:
 */
#define ULW_DRAW_AMOUNT_COMPLETE	0
#define ULW_DRAW_AMOUNT_STATUS		1
#define ULW_DRAW_AMOUNT_LIST		2


/*
 *	Universe List Window:
 */
struct _xsw_unvlist_win_struct {

	bool_t		map_state,
			has_focus,
			disabled;
	int		freeze_count,
			busy_count;
	int		x, y;
	unsigned int	width, height;
	visibility_t	visibility_state;

	win_t		toplevel;

	menu_bar_struct	mb;
	list_struct	list;

	/* Status Bar */
	win_t		status;
	pixmap_t	status_buf;

	/* Right click menu */
	menu_struct	menu;

	atom_t		target_xsw_universe_item;

};


/* unvlistwin.cpp */
extern "C" pixmap_t ULWGetItemIcon(
	unvitem_struct *uitem, bitmap_t *mask_rtn
);

extern "C" xsw_unvlist_win_struct *UnvListWinNew(void);
extern "C" void UnvListWinResize(xsw_unvlist_win_struct *ulw);
extern "C" void UnvListWinDraw(xsw_unvlist_win_struct *ulw, const int amount);
extern "C" int UnvListWinManage(xsw_unvlist_win_struct *ulw, event_t *event);
extern "C" void UnvListWinMap(xsw_unvlist_win_struct *ulw);
extern "C" void UnvListWinUnmap(xsw_unvlist_win_struct *ulw);
extern "C" void UnvListWinDelete(xsw_unvlist_win_struct *ulw);


#endif	/* UNIVLISTWIN_H */
