#ifndef XSWACTION_H
#define XSWACTION_H


/*
 *	Actions:
 */
#define XSW_ACTION_NONE			0
#define XSW_ACTION_EXIT			1
#define XSW_ACTION_EXIT_CONFIRM		2

#define XSW_ACTION_CLIENT_CMD		5
#define XSW_ACTION_SERVER_CMD		6

/* 10 - 99 Open/Save Files */
#define XSW_ACTION_RUN_SERVER		10
#define XSW_ACTION_OPEN_OCSN		20
#define XSW_ACTION_OPEN_IMGREFS		21
#define XSW_ACTION_OPEN_SNDREFS		22
#define XSW_ACTION_SERVER_SCRIPT	30
#define XSW_ACTION_STARCHART_OVERLAY	40
#define XSW_ACTION_STARCHART_OPEN	41
#define XSW_ACTION_STARCHART_SAVE_AS	42
#define XSW_ACTION_STARCHART_SAVE_IMAGE	43

/* 100 - 199 Network actions */
#define XSW_ACTION_CONNECT		100
#define XSW_ACTION_CONNECT_LAST		101
#define XSW_ACTION_DISCONNECT		110
#define XSW_ACTION_REFRESH		120
#define XSW_ACTION_AUTO_INTERVAL	150
#define XSW_ACTION_NET_INTERVAL_INC	155
#define XSW_ACTION_NET_INTERVAL_DEC	156

/* 200 - 299 Game Play Controls */
#define XSW_ACTION_LIGHTS_VECTOR	200
#define XSW_ACTION_LIGHTS_STROBE	201
#define XSW_ACTION_LIGHTS_LUMINATION	202

#define XSW_ACTION_WEAPON_FREQ		210
#define XSW_ACTION_SHIELD		213
#define XSW_ACTION_SHIELD_FREQ		214
#define XSW_ACTION_DMGCTL		215
#define XSW_ACTION_CLOAK		217
#define XSW_ACTION_INTERCEPT_SET	220
#define XSW_ACTION_HAIL			225
#define XSW_ACTION_COM_CHANNEL_SET	226
#define XSW_ACTION_SEND_MESSAGE		227
#define XSW_ACTION_IGNORE_OBJECT	228

#define XSW_ACTION_VIEWSCREEN_ZOOM_IN	230
#define XSW_ACTION_VIEWSCREEN_ZOOM_OUT	231
#define XSW_ACTION_VIEWSCREEN_ZOOM_AUTO	233

#define XSW_ACTION_SCANNER_ZOOM_IN	240
#define XSW_ACTION_SCANNER_ZOOM_OUT	241
#define XSW_ACTION_SCANNER_ZOOM_MIN	242
#define XSW_ACTION_SCANNER_ZOOM_MAX	243
#define XSW_ACTION_SCANNER_ORIENT	244

#define XSW_ACTION_ENGINE_STATE		250
#define XSW_ACTION_THROTTLE_MODE	251
#define XSW_ACTION_AUTO_DESTRUCT	255

#define XSW_ACTION_LOCK_NEXT		260
#define XSW_ACTION_LOCK_NEAREST		261
#define XSW_ACTION_UNLOCK		265
#define XSW_ACTION_TRACTOR_BEAM_LOCK	266
#define XSW_ACTION_TRACTOR_BEAM_UNLOCK	267

#define XSW_ACTION_WEAPONS_ONLINE	270
#define XSW_ACTION_WEAPON_SELECT_NEXT	275
#define XSW_ACTION_WEAPON_SELECT_PREV	276
#define XSW_ACTION_WEAPON_SELECT_1	280
#define XSW_ACTION_WEAPON_SELECT_2	281
#define XSW_ACTION_WEAPON_SELECT_3	282
#define XSW_ACTION_WEAPON_SELECT_4	283
#define XSW_ACTION_WEAPON_SELECT_5	284
#define XSW_ACTION_WEAPON_SELECT_6	285
#define XSW_ACTION_WEAPON_SELECT_7	286
#define XSW_ACTION_WEAPON_SELECT_8	287
#define XSW_ACTION_WEAPON_SELECT_9	288
#define XSW_ACTION_WEAPON_SELECT_10	289

/* 300 - 399 Systems and display */
#define XSW_ACTION_VS_MARKINGS		300	/* Viewscreen markings */
#define XSW_ACTION_VS_LABELS		301	/* Viewscreen labels */
#define XSW_ACTION_ENERGY_SAVER_MODE	302	/* Toggle Energy Saver Mode */
#define XSW_ACTION_MESSAGES		310
#define XSW_ACTION_ECONOMY		315
#define XSW_ACTION_STARCHART		316
#define XSW_ACTION_OPTIONS		320
#define XSW_ACTION_KEYMAP		321	/* Map keyboard */
#define XSW_ACTION_JSMAP		322	/* Map joystick */
#define XSW_ACTION_VSMENU_WIN		323	/* Map vsmenu window */

/* 400 - 499 Server Commands */
#define XSW_ACTION_WHO			401
#define XSW_ACTION_NETSTAT		402


/* 1000 - 1999 Menus */
#define XSW_ACTION_GOTO_MAIN		1000
#define XSW_ACTION_GOTO_DESTROYED	1010



/* xswaction.cpp */
extern "C" void XSWAction(
	const int action,		/* Action */
	void *arg,			/* Argument */
	void *win,			/* Window structure */
	const time_t cur_ms, const time_t cur_sec, const float tc
);


#endif	/* XSWACTION_H */
