#ifndef XSWIMGREFS_H
#define XSWIMGREFS_H

#include "../include/imgrefs.h"
#include "../include/objects.h"
#include "particle.h"


extern "C" imgref_struct *ImgRefGetPtr(
	imgref_struct **imgrefs_list, const int nimgrefs,
	const int imgref_num
);
extern "C" int ImgRefIsLoaded(imgref_struct *imgref);

extern "C" void ImgRefReset(
	imgref_struct **imgrefs_list, const int nimgrefs,
	const int imgref_num
);

extern "C" int ImgRefCreateExplicit(
	imgref_struct ***imgrefs_list, int *nimgrefs,
	const int imgref_num                         
);

extern "C" int ImgRefLoadAsDefault(
	imgref_struct ***imgrefs_list, int *nimgrefs,
	const int imgref_num                         
);
extern "C" int ImgRefLoad(
	imgref_struct ***imgrefs_list, int *nimgrefs,
	const int imgref_num
);

extern "C" void ImgRefUnload(
	imgref_struct **imgrefs_list, const int nimgrefs,
	const int imgref_num                             
);
extern "C" void ImgRefClear(imgref_struct ***imgrefs_list, int *nimgrefs);

extern "C" void ImgRefReclaimMemory(
	imgref_struct ***imgrefs_list, int *nimgrefs,
	xsw_object_struct **objs_list, const int nobjs,
	xsw_particle_struct **particles_list, const int nparticles
);

extern "C" void ImgRefManage(
	imgref_struct ***imgrefs_list, int *nimgrefs,
	const time_t cur_ms, const time_t cur_sec, const float tc,
	void (*load_completed_cb)(const int, void *),             
	void *load_completed_data
);


#endif	/* XSWIMGREFS_H */
