/*
		   XShipWars: Standard Sound Codes

	These are standardized sound codes.

	For the client, each sound code corresponds
	to a sound scheme code number on the client.

 */


#ifndef SWSOUNDCODES_H
#define SWSOUNDCODES_H


/* 0 to 9 - Basics & Menus */
#define SW_SNDREF_DEFAULT		0	/* All purpose default sound
						 * when no other sound is
						 * available.
						 */
#define SW_SNDREF_BUTTON_PRESS		1	/* Button press */
#define SW_SNDREF_STD_ERROR		2	/* Standard error */
#define SW_SNDREF_XSW_LOGO		3	/* "The XSW Sound" */
#define SW_SNDREF_MENU_HIGHLIGHT	4	/* Highlight item on menu */
#define SW_SNDREF_MENU_SELECT		5	/* Select item on menu */


/* 10 to 19 - Beeps & Blips */
#define SW_SNDREF_ATTENTION1		10
#define SW_SNDREF_ATTENTION2		11
#define SW_SNDREF_ANTIMATTER_LOW	12
#define SW_SNDREF_CHANNEL_OPEN		13
#define SW_SNDREF_INCOMING_PROJECTILE_ALERT	14
#define SW_SNDREF_INCOMING_MESG_BEEP	15
#define SW_SNDREF_SCAN_BEEP		16
#define SW_SNDREF_CONTACTS_BEEP		17
#define SW_SNDREF_HAIL_OUTGOING		18
#define SW_SNDREF_HAIL_INCOMING		19


/* 20 - 29 Operations Sounds */
#define SW_SNDREF_ENGINES_ON		20
#define SW_SNDREF_ENGINES_OFF		21
#define SW_SNDREF_CLOAK_UP		22
#define SW_SNDREF_CLOAK_DOWN		23
#define SW_SNDREF_SHIELD_UP		24
#define SW_SNDREF_SHIELD_DOWN		25
#define SW_SNDREF_TRACTOR_BEAM_ENGAGE	26
#define SW_SNDREF_TRACTOR_BEAM_DISENGAGE	27
#define SW_SNDREF_TRANSPORTER_BEAM_UP	28
#define SW_SNDREF_TRANSPORTER_BEAM_DOWN	29


/* 30 to 39 - Weapons Firing/Use */
#define SW_SNDREF_FIRE_STREAM		30
#define SW_SNDREF_FIRE_PULSE		31
#define SW_SNDREF_FIRE_PROJECTILE	32


/* 40 to 49 - Looping Effects */
#define SW_SNDREF_LOOP_TRACTOR_BEAM	45


/* 50 to 69 - Explosions */
#define SW_SNDREF_COLLIDE_HULL		50

#define SW_SNDREF_HIT_SHIELDS		53
#define SW_SNDREF_HIT_STRUCTURE		54

#define SW_SNDREF_OHIT_SHIELDS		55
#define SW_SNDREF_OHIT_STRUCTURE	56


/* 90 to 99 - Alerts */
#define SW_SNDREF_ALERT_RED		90
#define SW_SNDREF_ALERT_YELLOW		91
#define SW_SNDREF_EVENT_WARNING		95
#define SW_SNDREF_AUTO_DESTRUCT_BEEP	97	/* Not explosion */


/* 100 to 129 - In Game Background Music */
#define SW_SNDREF_BG_MUSIC_STANDARD		100
#define SW_SNDREF_BG_MUSIC_EXPLORING		101
#define SW_SNDREF_BG_MUSIC_ENGAGING		102
#define SW_SNDREF_BG_MUSIC_NEBULA		103
#define SW_SNDREF_BG_MUSIC_ASTEROID_FIELD	104


/* 200 to 219 - Menu Background Music */
#define SW_SNDREF_BG_MUSIC_MENU_MAIN		200
#define SW_SNDREF_BG_MUSIC_MENU_DESTROYED	201


#endif /* SWSOUNDCODES_H */
