/*
		     Universe Object Matching

 */

#ifndef UNVMATCH_H
#define UNVMATCH_H

#include "objects.h"


extern char UNVIsObjectGarbage(
	xsw_object_struct **xsw_object, int total_objects,
	int n
);
extern char UNVIsObjectNameIndex(const char *name);

extern float UNVGetObjectVisibility(
	xsw_object_struct **xsw_object, int total_objects,
	int n
);
extern float UNVGetObjectVisibilityPtr(xsw_object_struct *obj);

extern float UNVGetObjectEffectiveScannerRange(
	xsw_object_struct **xsw_object, int total_objects,
	int n
);
extern float UNVGetObjectEffectiveScannerRangePtr(
	xsw_object_struct *obj
);

extern char UNVIsObjectInEffectiveScannerRange(
	xsw_object_struct **xsw_object, int total_objects,
	int obj_num, int tar_obj_num,
	float scanner_range
);
extern char UNVIsObjectInEffectiveScannerRangePtr(
	xsw_object_struct *obj, xsw_object_struct *tar_obj,
	float scanner_range
);

extern int UNVMatchIntercept(
	xsw_object_struct **xsw_object, int total_objects,
	int obj_num,
	const char *arg
);
extern int UNVMatchInterceptByNumber(
	xsw_object_struct **xsw_object, int total_objects,
	int ref_obj_num, int tar_obj_num
);

extern int UNVMatchObjectByName(
	xsw_object_struct **xsw_object, int total_objects,
	const char *name, int type
);

extern int UNVMatchObjectNearest(
	xsw_object_struct **xsw_object, int total_objects,
	int obj_num, int type
);

extern int UNVMatchIFF(
	xsw_object_struct **xsw_object, int total_objects,
	int ref_obj_num, int tar_obj_num
);
extern int UNVMatchIFFPtr(
	xsw_object_struct *ref_obj, xsw_object_struct *tar_obj
);


#endif	/* UNVMATCH_H */
