/*
		Universe Objects Management Utility
 */

#ifndef UNVUTIL_H
#define UNVUTIL_H

#include "objects.h"


extern "C" int UNVAllocScores(xsw_object_struct *obj);
extern "C" int UNVAllocObjectWeapons(
	xsw_object_struct *obj, int total_weapons
);
extern "C" int UNVAllocEco(xsw_object_struct *obj);

extern "C" const char *UNVGetObjectFormalName(
	const int obj_num, xsw_object_struct *obj
);
extern "C" xsw_object_struct *UNVDupObject(xsw_object_struct *obj);
extern "C" void UNVResetObject(xsw_object_struct *obj);
extern "C" void UNVDeleteObject(xsw_object_struct *obj);
extern "C" void UNVDeleteAllObjects(xsw_object_struct **list, int total);

extern "C" void UNVParseLocation(
	const char *s,
	long *sect_x, long *sect_y, long *sect_z,
	float *x, float *y, float *z
);
extern "C" void UNVLocationFormatString(
	char *s,
	const long *sect_x, const long *sect_y, const long *sect_z,
	const float *x, const float *y, const float *z,
	int len
);

extern "C" void UNVParseDirection(  
	const char *s,
	float *heading, float *pitch, float *bank
);
extern "C" void UNVDirectionFormatString(
	char *s,
	const float *heading, const float *pitch, const float *bank,
	int len
);


#endif	/* UNVUTIL_H */
