/*
			      ShipWars Economy
 */

#ifndef ECO_H
#define ECO_H


/*
 *	Standard Economy Product Names:
 *
 *	(Case insensitive matched)
 */
#define SW_ECO_PROD_NAME_ANTIMATTER	"Antimatter"
#define SW_ECO_PROD_NAME_HULL_REPAIR	"Hull Repair"
#define SW_ECO_PROD_NAME_RMU		"Raw Material"

#define SW_ECO_PROD_NAME_OPMPFX		"$OPM"

#define SW_ECO_PROD_OCS_ANTIMATTER	10
#define SW_ECO_PROD_OCS_HULL_REPAIR	11
#define SW_ECO_PROD_OCS_RMU		12


/*
 *	Economy Flags:
 */
#define ECO_FLAG_OPEN		(1 << 0)	/* Opened for business */
#define ECO_FLAG_BUY_OK		(1 << 1)	/* Can buy from me */
#define ECO_FLAG_SELL_OK	(1 << 2)	/* Can sell to me */
#define ECO_FLAG_TRADE_OK	(1 << 3)	/* Can trade with me */
#define ECO_FLAG_INTRODUCE_OK	(1 << 4)	/* Create from thin air */

#define ECO_FLAG_NAME_OPEN		"OPEN"
#define ECO_FLAG_NAME_BUY_OK		"BUY_OK"
#define ECO_FLAG_NAME_SELL_OK		"SELL_OK"
#define ECO_FLAG_NAME_TRADE_OK		"TRADE_OK"
#define ECO_FLAG_NAME_INTRODUCE_OK	"INTRODUCE_OK"

/* 
 *	Economy Maximums:
 */                                              
#define ECO_PRODUCTS_MAX		32
#define ECO_PRODUCT_NAME_MAX		81


/*
 *	Maximum Transaction Range (in real units):
 */
#define ECO_MAX_TRANSACTION_RANGE	1.0


/*
 *      Economy flags mask type:
 */
typedef unsigned long eco_flags_t;




#endif /* ECO_H */
