#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef PLUGIN_SUPPORT
#include "plugins.h"
#endif
#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdHelp(int condescriptor, const char *arg)
{
	char sndbuf[CS_DATA_MAX_LEN];


	/* Print surface level server commands */
	sprintf(
	    sndbuf,
"boot  create  createp  chown  disk  ecoprodcreate  ecoproddelete  ecoprodset  eta  examine"
	);
	NetSendMessage(condescriptor, sndbuf);

	sprintf(
	    sndbuf,
"find  help  id  laston  link  memory  netstat  password  plugin  recover  recycle  recycleplayer"
	);
	NetSendMessage(condescriptor, sndbuf);

	sprintf(
	    sndbuf,
"save  score  set  shutdown  signup  siteban  synctime  sysparm  uptime  wall  who"
	);
	NetSendMessage(condescriptor, sndbuf);

#ifdef PLUGIN_SUPPORT
	/* Print plugins commands */
	if(total_plugins > 0)
	{
	    int i, n, len, strc;
	    const char **strv, *s;

	    for(i = 0; i < total_plugins; i++)
	    {
		strv = (const char **)PluginHelpCommandList(
		    i, &strc
		);
		if(strv != NULL)
		{
		    len = 0;
		    *sndbuf = '\0';
		    for(n = 0; n < strc; n++)
		    {
			s = strv[n];
			if(s == NULL)
			    continue;

			len += strlen(s) + 3;
			if(len < CS_DATA_MAX_LEN)
			{
			    strcat(sndbuf, s);
			    strcat(sndbuf, "  ");
			}
		    }
		    /* Do not delete strv or any of its pointers, they
		     * are all statically allocated
		     */

		    /* Print this string of commands if it has exceeded
		     * 75 characters in length
		     */
		    if(len > 75)
		    {
			/* Send out line and reset send buffer */
			NetSendMessage(condescriptor, sndbuf);
			len = 0;
			*sndbuf = '\0';
		    }

		    /* Send out last bufered line (if any) */
		    if(*sndbuf != '\0')
			NetSendMessage(condescriptor, sndbuf);
		}
	    }
	}
#endif

	return(0);
}
