#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdID(const int con_num, const char *arg);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)
 
 
/*
 *      Check user ID and group ID of object.
 */
int CmdID(const int con_num, const char *arg)
{
	int con_obj_num, obj_num;
	const char *name;
	char *sndbuf;
	xsw_object_struct *obj, *con_obj;
	sws_connection_struct *con = connection[con_num];

	/* Get connection's object number (assumed valid) */
	con_obj_num = con->object_num;
	con_obj = xsw_object[con_obj_num];

	if((arg == NULL) ? 1 : (*arg == '\0'))
	{
	    if(!DBIsObjectGarbage(con_obj->locked_on))
		obj_num = con_obj->locked_on;
	    else
		obj_num = con_obj_num;
	}
	else if(!strcasecmp(arg, "me"))
	{
	    obj_num = con_obj_num;
	}
        else if(!strcasecmp(arg, "this"))
        {
            obj_num = con_obj->locked_on;
        }
	else
	{
	    obj_num = UNVMatchObjectByName(
		xsw_object, total_objects,
		arg, SW_OBJ_TYPE_PLAYER
	    );
	}
	if(DBIsObjectGarbage(obj_num))
	{
	    char *s = (char *)malloc(STRLEN(arg) + 80);
	    sprintf(
		s,
"%s: No such player.",
		arg
	    );
	    NetSendMessage(con_num, s);
	    free(s);
	    return(-1);
	}

	obj = xsw_object[obj_num];

	/* Print ID */
	name = DBGetFormalNameStr(obj_num);
	sndbuf = (char *)malloc(STRLEN(name) + 40 + 40 + 80);
	sprintf(
	    sndbuf,
	    "%s: uid: %i  gid: %i",
	    name,
	    obj->permission.uid,
	    obj->permission.gid
	);
	NetSendMessage(con_num, sndbuf);
	free(sndbuf);

	return(0);
}
