#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdSaveUniverse(const int con_num, const char *arg);


#define THIS_CMD_NAME	"save"

#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


int CmdSaveUniverse(const int con_num, const char *arg)
{
	sws_connection_struct *con = connection[con_num];
	const int con_obj_num = con->object_num;
	xsw_object_struct *obj = xsw_object[con_obj_num];

	/* Permission check */
	if(obj->permission.uid > SWS_ACCESS_UID_SAVE)
	{
	    char *s = (char *)malloc(
		STRLEN(THIS_CMD_NAME) + 40 + 80
	    );
	    sprintf(
		s,
"%s: Permission denied: Requires access level %i.",
		THIS_CMD_NAME, SWS_ACCESS_UID_SAVE
	    );
	    NetSendMessage(con_num, s);
	    free(s);
	    return(-1);
	}

	/* Log */
	if(sysparm.log_general)
	{
	    char *name = STRDUP(DBGetFormalNameStr(con_obj_num));
	    char *s = (char *)malloc(STRLEN(name) + 80);
	    sprintf(
		s,
"%s: Saved the universe.",
		name
	    );
	    LogAppend(fname.log, s);
	    free(s);
	    free(name);
	}

	/* Save the universe */
	SWSSaveUnv();

	/* Schedual the next universe save */
	next.unv_save = cur_systime + sysparm.int_unv_save;

	return(0);
}
