#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdScore(const int con_num, const char *arg);


#define THIS_CMD_NAME	"score"

#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


int CmdScore(const int con_num, const char *arg)
{
	int obj_num;
	char *sndbuf;
	sw_legend_struct *legend = &sw_legend;
	xsw_object_struct *obj;
	xsw_score_struct *score;
	sws_connection_struct *con = connection[con_num];
	const int con_obj_num = con->object_num;
	xsw_object_struct *con_obj = xsw_object[con_obj_num];

	/* Parse object number */
	if((arg != NULL) ? (*arg == '\0') : 1)
	{
	    if(con_obj->locked_on > -1)
		obj_num = con_obj->locked_on;
	    else
		obj_num = con_obj_num;
	}
	else if(!strcasecmp(arg, "me"))
	{
	    obj_num = con_obj_num;
	}
        else if(!strcasecmp(arg, "this"))
        {
            obj_num = con_obj->locked_on;
        }
	else
	{
	    obj_num = UNVMatchObjectByName(
		xsw_object, total_objects,
		arg, -1
	    );
	}
	if(DBIsObjectGarbage(obj_num))
	{
	    sndbuf = (char *)malloc(STRLEN(arg) + 80);
	    sprintf(
		sndbuf,
"%s: No such object.",
		arg
	    );
	    NetSendMessage(con_num, sndbuf);
	    free(sndbuf);
	    return(-1);
	}

	obj = xsw_object[obj_num];
	score = obj->score;
	if(score != NULL)
	{
	    char *name = STRDUP(obj->name);
	    sndbuf = (char *)malloc(
		STRLEN(name) +
		40 + 40 + 40 + 40 + 40 + 40 + 40 +
	        80
	    );
	    sprintf(
		sndbuf,
"%s: Credits: %.2f  RMU: %.2f(%.2f)  DmgGiv: %.2f  DmgRec: %.2f\
  Kills: %i  Odometer: %.0f au",
		name,
		score->credits,
		score->rmu,
		score->rmu_max,
		score->damage_given,
		score->damage_received,
		score->kills,
		MAX((obj->odometer * legend->ru_to_au), 0.0f)
	    );
	    free(name);
	    NetSendMessage(con_num, sndbuf);
	    free(sndbuf);
	}
	else
	{
	    char *name = STRDUP(obj->name);
	    sndbuf = (char *)malloc(STRLEN(name) + 80);
	    sprintf(
		sndbuf,
"%s: No scores.",
		name
	    );
	    free(name);
	    NetSendMessage(con_num, sndbuf);
	    free(sndbuf);
	}

	return(0);
}
