#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdVersion(const int con_num, const char *arg);


#define THIS_CMD_NAME		"version"

#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


/*
 *	Prints the version of this program to the connection.
 */
int CmdVersion(const int con_num, const char *arg)
{
	char *sndbuf = (char *)malloc(
	    STRLEN(PROG_NAME_FULL) + STRLEN(PROG_VERSION) + 80
	);
	sprintf(
	    sndbuf,
"%s Version %s.",
	    PROG_NAME_FULL,
	    PROG_VERSION
	);
	NetSendMessage(con_num, sndbuf);
	free(sndbuf);

	return(0);
}
