#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"
#include "../include/unvmatch.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdWall(const int con_num, const char *arg);


#define THIS_CMD_NAME		"wall"

#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


/*
 *	Prints message to all connections.
 */
int CmdWall(const int con_num, const char *arg)
{
	const char *name;
	char *sndbuf, msg[CS_MESG_MAX];
	sws_connection_struct *con = connection[con_num];
	const int con_obj_num = con->object_num;
	xsw_object_struct *con_obj = xsw_object[con_obj_num];

	if(STRISEMPTY(arg))
	{
	    sndbuf = (char *)malloc(STRLEN(THIS_CMD_NAME) + 80);
	    sprintf(
		sndbuf,
"Usage: `%s <message>'",
		THIS_CMD_NAME
	    );
	    NetSendMessage(con_num, sndbuf);
	    free(sndbuf);
	    return(0);
	}

/* Check if the player has permission to send a wall message */

	strncpy(msg, arg, sizeof(msg));
	msg[sizeof(msg) - 1] = '\0';
	strstrip(msg);

	name = con_obj->name;
	sndbuf = (char *)malloc(STRLEN(name) + STRLEN(msg) + 80);
	sprintf(
	    sndbuf,
"<%s>: \"%s\"",
	    name, msg
	);
	NetSendMessage(-1, sndbuf);
	free(sndbuf);

	return(0);
}
