#ifndef SWSERV_ECO_H		/* to avoid conflicts with the global eco.h */
#define SWSERV_ECO_H

#include "../include/objects.h"


/* eco.cpp */
extern int EcoBuy(
	const int con_num,
	const int customer_num, const int proprietor_num,
	xsw_ecoproduct_struct *product
);
extern int EcoSell(
	const int con_num,
	const int customer_num, const int proprietor_num,
	xsw_ecoproduct_struct *product
);

/* ecoutils.cpp */
extern int EcoGetOCSFromName(const char *s, int start_ocs_num);
extern int EcoGetWeaponNumByName(
	xsw_object_struct *obj, const char *name
);

extern int EcoGetProductNumByName(const int obj_num, const char *name);
extern int EcoGetProductNumByOCSCode(const int obj_num, const int ocs_code);

extern sw_credits_t EcoTransCredits(
	const int obj_num, const sw_credits_t d_credits
);

extern void EcoNotifyBuy(
	const int con_num,
	const char *product_name, const char *proprietor_name,
	const float total_amount, const float total_price
);
extern void EcoNotifySell(
	const int con_num,
	const char *product_name, const char *proprietor_name,
	const float total_amount, const float total_price     
);

extern int EcoAdjustPriceAuto(
	xsw_ecoproduct_struct *product, const float diff_amount
);


#endif	/* SWSERV_ECO_H */
