#ifndef EFFECTS_H
#define EFFECTS_H

#include "../include/objects.h"


/* Debris */
extern int EffectsCreateDebrisObject(
	const int obj_num, xsw_object_struct *obj,
	const time_t cur_ms, const time_t cur_sec, const float tc
);

/* Explosions */
extern void EffectsCreateExplosionSmall(
	const int obj_num, xsw_object_struct *obj,
	long sect_x, long sect_y, long sect_z,
	float x, float y, float z,
	float heading, float pitch, float bank
);
extern void EffectsCreateExplosionMedium(
	const int obj_num, xsw_object_struct *obj,
	long sect_x, long sect_y, long sect_z,
	float x, float y, float z,
	float heading, float pitch, float bank
);
extern void EffectsCreateExplosionLarge(
	const int obj_num, xsw_object_struct *obj,
	long sect_x, long sect_y, long sect_z,
	float x, float y, float z,
	float heading, float pitch, float bank
);

/* Shockwaves */
extern void EffectsCreateShockwave(
	const int obj_num, xsw_object_struct *obj,
	long size_min, long size_max,
	float damage_hull, float damage_shield
);

/* Object Fires */
extern void EffectsSetObjectOnFire(
	const int obj_num, xsw_object_struct *obj,
	const char is_on_fire
);

/* Object Smoke Trails */
extern void EffectsSetObjectSmokeTrail(
	const int obj_num, xsw_object_struct *obj,
	const char has_smoke_trail
); 


#endif	/* EFFECTS_H */
