#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/reality.h"
#include "../include/objects.h"
#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleSetChannel(const int con_num, const char *arg);
void NetSendSetChannel(
        const int con_num, const int obj_num,
        const int channel
);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleSetChannel(const int con_num, const char *arg)
{
	int obj_num = -1;
	int channel = 0;
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[con_num];
	const int con_obj_num = con->object_num;

	/* SWEXTCMD_SETCHANNEL format:
	 *
	 *	obj_num channel
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &obj_num, &channel
	);

	if(con_obj_num != obj_num)
	    return;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];

	if(channel > (int)(SW_FREQ_MAX * 100.0f))
	    channel = (int)(SW_FREQ_MAX * 100.0f);
	else if(channel < (int)(SW_FREQ_MIN * 100.0f))
	    channel = (int)(SW_FREQ_MIN * 100.0f);

	/* Set channel */
	obj->com_channel = channel;

	/* Update the com channel to the object */
	NetSendSetChannel(con_num, obj_num, channel);
}


void NetSendSetChannel(
	const int con_num, const int obj_num,
	const int channel
)
{
	char *sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + 40 +
	    80
	);

	/* SWEXTCMD_SETCHANNEL format:
	 *
	 *	obj_num channel
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %i\n",
	    CS_CODE_EXT, SWEXTCMD_SETCHANNEL,
	    obj_num, channel
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
