#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleCreateEffect(const int con_num, const char *arg);
void NetSendCreateEffect(
	const int con_num,
	const unsigned int flags,
	const int imgref_num,
	const long sect_x, const long sect_y, const long sect_z,
	const float x, const float y, const float z,
	const long size_min, const long size_max,
	const time_t life_span,
	const int ref_obj_num
);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleCreateEffect(const int con_num, const char *arg)
{

}

void NetSendCreateEffect(
	const int con_num,
	const unsigned int flags,
	const int imgref_num,
	const long sect_x, const long sect_y, const long sect_z,
	const float x, const float y, const float z,
	const long size_min, const long size_max,
	const time_t life_span,
	const int ref_obj_num
)
{
	char *sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + 40 +
	    40 + 40 + 40 +
	    40 + 40 + 40 +
	    40 + 40 + 40 + 40 + 80
	);

	/* SWEXTCMD_CREATE_EFFECT format:
	 *
	 *	flags imgref_num sect_x sect_y sect_z x y z
	 *	size_min size_max life_span ref_obj_num
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %ui %i\
 %ld %ld %ld\
 %.4f %.4f %.4f\
 %ld %ld %ld %i\n",
	    CS_CODE_EXT,
	    SWEXTCMD_CREATE_EFFECT,
	    flags, imgref_num,
	    sect_x, sect_y, sect_z, x, y, z,
	    size_min, size_max, (long)life_span, ref_obj_num
	);
	NetSendDataWithInScannerRange(
	    sndbuf,
	    sect_x, sect_y, sect_z,
	    x, y, z,
	    MAX(size_min, size_max)
	);
	free(sndbuf);
}
