#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleNotifyDestroy(int con_num, const char *arg);
void NetSendNotifyDestroy(
	int con_num,
	int reason,			/* One of SW_DESTROY_REASON_* */
	int destroyed_obj_num,
	int destroyer_obj_num,
	int destroyer_obj_owner_num
);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleNotifyDestroy(int con_num, const char *arg)
{

}


void NetSendNotifyDestroy(
	int con_num,
	int reason,			/* One of SW_DESTROY_REASON_* */
	int destroyed_obj_num,
	int destroyer_obj_num,
	int destroyer_obj_owner_num
)
{
	char *sndbuf = (char *)malloc(
	    40 + 40 +
	    40 +
	    40 + 40 +
	    40 +
	    80
	);

	/* SWEXTCMD_NOTIFYDESTROY format:
	 *
	 *	reason
	 *	destroyed_obj_num
	 *	destroyer_obj_num
	 *	destroyer_obj_owner_num
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i\
 %i %i\
 %i\n",
	    CS_CODE_EXT,
	    SWEXTCMD_NOTIFYDESTROY,
	    reason,
	    destroyed_obj_num, destroyer_obj_num,
	    destroyer_obj_owner_num
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
