#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleSetDmgCtl(
	const int con_num, const char *arg,
        const time_t cur_ms, const time_t cur_sec, const float tc
);
void NetSendSetDmgCtl(const int con_num, const int obj_num);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleSetDmgCtl(
	const int con_num, const char *arg,
        const time_t cur_ms, const time_t cur_sec, const float tc
)
{
	int obj_num = -1;
	int dmgctl = SW_DMGCTL_STATE_OFF;
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[con_num];
	const int con_obj_num = con->object_num;

	/* SWEXTCMD_SETDMGCTL format:
	 *
	 *	obj_num dmgctl
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &obj_num, &dmgctl
	);

	if(obj_num != con_obj_num)
	    return;

        if(DBIsObjectGarbage(obj_num))
            return;

        obj = xsw_object[obj_num];

	/* Turn damage control on? */   
	if((obj->damage_control == SW_DMGCTL_STATE_OFF) &&
	   (dmgctl == SW_DMGCTL_STATE_ON)
	)
	{
	    obj->damage_control = SW_DMGCTL_STATE_ON;
	}
	/* Turn damage control off? */
	else if((obj->damage_control == SW_DMGCTL_STATE_ON) &&
		(dmgctl == SW_DMGCTL_STATE_OFF)
	)
	{   
	    obj->damage_control = SW_DMGCTL_STATE_OFF;
	}


	/* Set next object values update to now so it gets updated now */
	next.object_values = cur_ms;
}


void NetSendSetDmgCtl(const int con_num, const int obj_num)
{
	return;
}
