#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetSendELinkFoward(int con_num, const char *url);
void NetHandleELinkEnter(int con_num, const char *arg);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetSendELinkFoward(int con_num, const char *url)
{
	char *sndbuf;

	if(url == NULL)
	    return;

	sndbuf = (char *)malloc(
	    40 + STRLEN(url) + 80
	);

	/* CS_CODE_FORWARD forward:
	 *
	 *	url
	 */
	sprintf(
	    sndbuf,
"%i %s\n",
	    CS_CODE_FORWARD,
	    url
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}

void NetHandleELinkEnter(int con_num, const char *arg)
{
	int src_obj_num, tar_obj_num;
	xsw_object_struct *tar_obj;

	/* SWEXTCMD_ELINKENTER format:
	 *
	 *	src_obj_num tar_obj_num
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &src_obj_num, &tar_obj_num
	);

	if(DBIsObjectGarbage(tar_obj_num))
	    return;

	tar_obj = xsw_object[tar_obj_num];

	/* Check if object is a elink */
	if(tar_obj->type != SW_OBJ_TYPE_ELINK)
	    return;

	/* Set forward to url */
	NetSendELinkFoward(con_num, tar_obj->elink);
}
