#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleNotifyHit(const int con_num, const char *arg);
void NetSendNotifyHit(
	const int con_num,
	const int wobj_num, const int tobj_num,
	const float bearing,		/* Target to weapon */
	const float dmg_structure,
	const float dmg_shield
);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleNotifyHit(const int con_num, const char *arg)
{

}


void NetSendNotifyHit(
	const int con_num,
	const int wobj_num, const int tobj_num,
	const float bearing,		/* Target to weapon */
	const float dmg_structure,
	const float dmg_shield
)
{
	const float dmg_total = dmg_structure + dmg_shield;
	char *sndbuf;
	xsw_object_struct *tar_obj;

	if(DBIsObjectGarbage(tobj_num))
	    return;

	tar_obj = xsw_object[tobj_num];

	sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + 40 +
	    40 + 40 +
	    40 + 40 +
	    40 + 40 +
	    80
	);

	/* SWEXTCMD_NOTIFYHIT format:
	 *
	 *	wobj_num tobj_num
	 *	dmg_total bearing dmg_structure dmg_shield
	 *	hp power
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %i\
 %.4f %.4f\
 %.4f %.4f\
 %.4f %.4f\n",
	    CS_CODE_EXT,
	    SWEXTCMD_NOTIFYHIT,
	    wobj_num, tobj_num,
	    dmg_total, bearing,
	    dmg_structure, dmg_shield,
	    tar_obj->hp, tar_obj->power
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
