#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleSetInterval(int condescriptor, const char *arg)
{
	long interval = 0l;
	sws_connection_struct *con = connection[condescriptor];

	if(!ConIsLoggedIn(condescriptor))
	    return;

	if(*arg == '\0')
	    return;

	/* NET_CMD_SETINTERVAL format:
	 *      
	 *	interval
	 */
	sscanf(
	    arg,
	    "%ld",
	    &interval
	);

	/* Clip interval */
	if(interval < SWS_MIN_OBJECT_UPDATE_INT)
	    interval = SWS_MIN_OBJECT_UPDATE_INT;
	else if(interval > SWS_MAX_OBJECT_UPDATE_INT)
	    interval = SWS_MAX_OBJECT_UPDATE_INT;

	/* Set new update interval */
	con->obj_update_int = interval;
}


void NetSendSetInterval(int condescriptor)
{
	return;
}
