#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"
#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleSetIntercept(
        const int con_num, const char *arg,
        const time_t cur_ms, const time_t cur_sec, const float tc
);
void NetSendSetIntercept(const int con_num, const int obj_num);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleSetIntercept(
        const int con_num, const char *arg,
        const time_t cur_ms, const time_t cur_sec, const float tc
)
{
	int obj_num = -1;
	const char *s;
	char intercept_arg[SW_OBJ_NAME_MAX];
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[con_num];
	const int con_obj_num = con->object_num;

        /* NET_CMD_INTERCEPT format:
         *
         *      obj_num argument
         */

	s = arg;
	obj_num = ATOI(s);
	while((*s != '\0') && (*s != ' '))
	    s++;
	while(*s == ' ')
	    s++;

	strncpy(intercept_arg, s, sizeof(intercept_arg));
	intercept_arg[sizeof(intercept_arg) - 1] = '\0';

	if(obj_num != con_obj_num)
	    return;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];

	/* Turn off intercept? */
	if((*intercept_arg == '\0') ||
           !strcasecmp(intercept_arg, "#off")
	)
	{
	    obj->intercepting_object = -1;
	}
	/* Intercept locked on object? */
	else if(strcasepfx(intercept_arg, "#l"))
	{
	    obj->intercepting_object = obj->locked_on;
	}
	else
	{
	    /* Match intercepting object */
	    obj->intercepting_object = UNVMatchIntercept(
		xsw_object, total_objects,
		obj_num, intercept_arg
	    );
	    if(obj->intercepting_object < 0)
	    {
		char *s = (char *)malloc(strlen(intercept_arg) + 80);
		sprintf(
		    s,
"Unable to find object `%s' to intercept.",
		    intercept_arg
		);
		NetSendMessage(con_num, s);
		free(s);
	    }
	}

	/* Set next object values update to now so it gets updated now */
	next.object_values = cur_ms;
}


void NetSendSetIntercept(const int con_num, const int obj_num)
{
	return;
}
