#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleSetLegend(const int con_num, const char *arg);
void NetSendLegend(const int con_num);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleSetLegend(const int con_num, const char *arg)
{
	NetSendLegend(con_num);
}

void NetSendLegend(const int con_num)
{
	sw_legend_struct *legend = &sw_legend;
	char *sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + 40 + 40 + 40 + 40 +
	    40 + 40 + 40 + 40 + 40 +
	    40 + 40 + 40 + 40 + 40 +
	    80
	);

	/* Format SWEXTCMD_SET_LEGEND:
	 *
	 *	ru_to_au
	 *	antimatter_low_warning 
	 *	asteroid_field_damage_int
	 *	asteroid_field_damage_rate
	 *	auto_destruct_damage_range
	 *	cloak_antimatter_rate
	 *	com_range
	 *	damage_control_rate
	 *	disarmed_weapon_lifespan
	 *	engine_antimatter_rate
	 *	no_antimatter_thrust_coeff
	 *	on_fire_hp_coeff
	 *	tractor_beam_antimatter_rate
	 *	tractor_beam_range
	 *	transporter_range
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %.5f\
 %.4f\
 %ld\
 %.4f\
 %.4f\
 %.4f\
 %.4f\
 %.4f\
 %ld\
 %.4f\
 %.4f\
 %.4f\
 %.4f\
 %.4f\
 %.4f\n",
	    CS_CODE_EXT, SWEXTCMD_SET_LEGEND,
	    legend->ru_to_au,
	    legend->antimatter_low_warning,
	    legend->asteroid_field_damage_int,
	    legend->asteroid_field_damage_rate,
	    legend->auto_destruct_damage_range,
	    legend->cloak_antimatter_rate,
	    legend->com_range,
	    legend->damage_control_rate,
	    legend->disarmed_weapon_lifespan,
	    legend->engine_antimatter_rate,
	    legend->no_antimatter_thrust_coeff,
	    legend->on_fire_hp_coeff,
	    legend->tractor_beam_antimatter_rate,
	    legend->tractor_beam_range,
	    legend->transporter_range
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
