#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"
#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


void NetHandleLogout(
        const int con_num, 
        const time_t cur_ms, const time_t cur_sec, const float tc   
);
void NetSendLogout(const int con_num);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleLogout(
	const int con_num,
        const time_t cur_ms, const time_t cur_sec, const float tc
)
{
	sw_legend_struct *legend = &sw_legend;
	sws_connection_struct *con = connection[con_num];
	int obj_num = con->object_num;
	if(DBIsObjectGarbage(obj_num))
	{
	    /* Never logged in */
	}
	else
	{
	    /* Send leave message to connection */
	    xsw_object_struct *obj = xsw_object[obj_num];
	    char	*s = STRDUP(sysparm.mesg_leave),
			*s2 = strsub(s, "%title", legend->title),
			*mesg;
	    free(s);
	    mesg = strsub(s2, "%name", obj->name);
	    free(s2);
	    NetSendMessage(con_num, mesg);
	    free(mesg);
	}

	/* Logout and shutdown the connection */
	if(!(con->flags & SWS_CON_FLAG_CLOSE_WAIT))
	    NetShutdownConnection(
		con_num,
		SWS_CON_SHUTDOWN_RDWR,	/* Shutdown both read and write */
		0,			/* We are not the disconnect initiator */
		cur_ms, cur_sec, tc
	    );
}


void NetSendLogout(const int con_num)
{
	char *sndbuf = (char *)malloc(
	    40 + 80
	);

	/* CS_CODE_LOGOUT format:
	 *
	 */
	sprintf(
	    sndbuf,
	    "%i\n",
	    CS_CODE_LOGOUT
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
