#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleCreateObject(const int con_num, const char *arg);
void NetSendCreateObject(const int con_num, const int obj_num);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleCreateObject(const int con_num, const char *arg)
{

}


void NetSendCreateObject(const int con_num, const int obj_num)
{
	char *sndbuf;
	xsw_animation_struct *anim;
	xsw_object_struct *obj;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];
	anim = &obj->animation;

	sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + 40 + 40 + 40 +
            40 + 40 + 40 +
            40 + 40 + 40 +
            40 + 40 + 40 +
            40 + 40 + 40 +
            40 +
            40 + 40 + 40 +
            40 + 40 + 40 + 40 +
            40 +
	    80
	);

	/* CS_CODE_CREATEOBJ format:
	 *
	 *	obj_num
	 *	type imgref_num owner size
	 *	locked_on intercepting_object scanner_range
	 *	sect_x sect_y sect_z
	 *	x y z
	 *	heading pitch bank
	 *	velocity
	 *	velocity_heading velocity_pitch velocity_bank
	 *	current_frame anim_int total_frames cycle_times
	 *	lifespan
	 *
	 *	27 args
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %i %i %ld\
 %i %i %.4f\
 %ld %ld %ld\
 %.4f %.4f %.4f\
 %.4f 0.0 0.0\
 %.4f\
 %.4f 0.0 0.0\
 %i %ld %i %i\
 %ld\n",
	    CS_CODE_CREATEOBJ,
	    obj_num,
	    obj->type, obj->imgref, obj->owner, obj->size,
	    obj->locked_on, obj->intercepting_object, obj->scanner_range,
	    obj->sect_x, obj->sect_y, obj->sect_z,
	    obj->x, obj->y, obj->z,
	    obj->heading,
	    obj->velocity,
	    obj->velocity_heading,
	    anim->current_frame,
	    anim->interval,
	    anim->total_frames,
	    anim->cycle_times,
	    obj->lifespan
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
