#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleObjectDescription(int con_num, const char *arg)
{
	int obj_num = -1;

	/* SWEXTCMD_REQDESCRIPTION format:
	 *
	 *	obj_num
	 */
	sscanf(
	    arg,
	    "%i",
	    &obj_num
	);

	if(DBIsObjectGarbage(obj_num))
	    return;

	NetSendObjectDescription(con_num, obj_num);
}


void NetSendObjectDescription(int con_num, int obj_num)
{
	char	*sndbuf,
		desc[CS_DATA_MAX_LEN - 40];
	xsw_object_struct *obj;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];
	if(obj->description == NULL)
	    return;

	strncpy(desc, obj->description, sizeof(desc));
	desc[sizeof(desc) - 1] = '\0';

	sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + STRLEN(desc) +
	    80
	);

	/* SWEXTCMD_SETDESCRIPTION format:
	 *
	 *	obj_num;description
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i;%s\n",
	    CS_CODE_EXT,
	    SWEXTCMD_SETDESCRIPTION,
	    obj_num,
	    desc
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
