#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetSendObjectForcePose(
	const int con_num, const int obj_num,
        const time_t cur_ms, const time_t cur_sec, const float tc 
);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetSendObjectForcePose(
	const int con_num, const int obj_num,
	const time_t cur_ms, const time_t cur_sec, const float tc
)
{
	int tar_con_num;
	char *sndbuf;
	xsw_object_struct *obj;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];

        sndbuf = (char *)malloc(
            40 + 40 +
            40 + 40 + 40 +
            40 + 40 + 40 +
            40 + 40 + 40 +
            40 +
            40 + 40 + 40 +
            40 + 80
        );

	/* CS_CODE_FORCEPOSEOBJ format:
	 *
	 *	obj_num
	 *	type imgref_num size
	 *	x y z
	 *	heading pitch bank
	 *	velocity
	 *	velocity_heading velocity_pitch velocity_bank
	 *	current_frame
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %i %ld\
 %.4f %.4f %.4f\
 %.4f 0 0\
 %.5f\
 %.4f 0 0\
 %i\n",
	    CS_CODE_FORCEPOSEOBJ,
	    obj_num,
	    obj->type, obj->imgref, obj->size,
	    obj->x, obj->y, obj->z,
	    obj->heading,
	    obj->velocity,
	    obj->velocity_heading,
	    obj->animation.current_frame
	);

        tar_con_num = ConGetByObject(obj_num);
        if(tar_con_num > -1)
        {
            sws_connection_struct *con = connection[tar_con_num];

	    /* Mark that the object is waiting for a force pose
	     * response
	     */
	    con->flags |= SWS_CON_FLAG_FPOSE_WAIT;

	    /* Update the last pose time with the current time + 1 so
	     * that any subsequent poses from the client that are to
	     * be handled on this same iteration will get ignored
	     */
	    con->obj_last_pose = cur_ms + 1l;
	}

	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
