#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleObjectMaximums(const int con_num, const char *arg);
void NetSendObjectMaximums(const int con_num, const int obj_num);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)

 
void NetHandleObjectMaximums(const int con_num, const char *arg)
{

}


void NetSendObjectMaximums(const int con_num, const int obj_num)
{
	char *sndbuf;
	xsw_object_struct *obj;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];

	sndbuf = (char *)malloc(
	    40 + 40 + 40 +
	    40 + 40 + 40 + 40 +
	    40 +
	    40 + 40 + 40 +
	    40 + 40 +
	    40 + 40 + 40 +
	    40 + 40 +
	    80
	);

	/* SWEXTCMD_STDOBJMAXS format:
	 *
	 *	type imgref_num owner size scanner_range
	 *	velocity_max thrust_power turnrate hp_max power_max
	 *	power_purity core_efficency antimatter_max total_weapons
	 *	visibility 
	 */
	sprintf(
	    sndbuf,
"%i %i %i\
 %i %i %i %ld\
 %.4f\
 %.5f %.5f %.5f\
 %.4f %.4f\
 %.4f %.4f %.4f\
 %i %.4f\n",

	    CS_CODE_EXT,
	    SWEXTCMD_STDOBJMAXS,
	    obj_num,
	    obj->type, obj->imgref, obj->owner, obj->size,
	    obj->scanner_range,
	    obj->velocity_max, obj->thrust_power, obj->turnrate,
	    obj->hp_max, obj->power_max,
	    obj->power_purity, obj->core_efficency, obj->antimatter_max,
	    obj->total_weapons, obj->visibility
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
