#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleObjectName(int con_num, const char *arg)
{
	int obj_num = -1;

	/* SWEXTCMD_REQNAME format:
	 *
	 *	obj_num
	 */
	sscanf(
	    arg,
	    "%i",
	    &obj_num
	);

	if(DBIsObjectGarbage(obj_num))
	    return;

	NetSendObjectName(con_num, obj_num);
}


void NetSendObjectName(int con_num, int obj_num)
{
	char *sndbuf;
	xsw_object_struct *obj;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];

	sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + STRLEN(obj->name) + STRLEN(obj->empire) +
	    80
	);
	/* SWEXTCMD_SETOBJNAME format:
	 *
	 *	obj_num;name;empire
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i;%s;%s\n",
	    CS_CODE_EXT,
	    SWEXTCMD_SETOBJNAME,
	    obj_num,
	    obj->name, obj->empire
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
