#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleScore(int con_num, const char *arg)
{
	int obj_num = -1;

	/* SWEXTCMD_SETSCORE format:
	 *
	 *	obj_num
	 */
	sscanf(
	    arg,
	    "%i",
	    &obj_num
	);
	NetSendScore(con_num, obj_num);
}


void NetSendScore(int con_num, int obj_num)
{
	char *sndbuf;
	xsw_object_struct *obj;
	xsw_score_struct *score;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];
	score = obj->score;
	if(score == NULL)
	    return;

	sndbuf = (char *)malloc(
	    40 + 40 +
	    40 +
	    40 + 40 + 40 +
	    40 + 40 + 40 +
	    80
	);

	/* SWEXTCMD_SETSCORE format:
	 *
	 *	obj_num 
	 *	credits rmu rmu_max
	 *	damage_given damage_received kills
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %.2f %.2f %.2f %.2f %.2f %i\n",
	    CS_CODE_EXT,
	    SWEXTCMD_SETSCORE,
	    obj_num,
	    score->credits, score->rmu, score->rmu_max,
	    score->damage_given, score->damage_received, score->kills
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
