#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandlePlaySound(const int con_num, const char *arg);
void NetSendPlaySound(
        const int con_num, const int sndref_num,
        const float left_volume, const float right_volume
);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandlePlaySound(const int con_num, const char *arg)
{

}


void NetSendPlaySound(
	const int con_num, const int sndref_num,
	const float left_volume, const float right_volume
)
{
	char *sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + 40 +
	    80
	);

	/* CS_CODE_PLAYSOUND format:
	 *
	 *	sndref_num left_volume, right_volume
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %.2f %.2f\n",
	    CS_CODE_PLAYSOUND,
	    sndref_num,
	    CLIP(left_volume, 0.0f, 1.0f),
	    CLIP(right_volume, 0.0f, 1.0f)
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
