#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleObjectThrottle(const int con_num, const char *arg);
void NetSendObjectThrottle(const int con_num);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleObjectThrottle(const int con_num, const char *arg)
{
	int obj_num = -1;
	float throttle = 0.0f;
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[con_num];
	const int con_obj_num = con->object_num;
	if(DBIsObjectGarbage(con_obj_num))
	    return;

	obj = xsw_object[con_obj_num];

	/* SWEXTCMD_SETTHROTTLE format:
	 *
	 *	obj_num throttle
	 */
	sscanf(
	    arg,
	    "%i %f",
	    &obj_num, &throttle   
	);
	if(obj_num != con_obj_num)
	    return;

	/* Set throttle value */
	obj->throttle = CLIP(throttle, 0.0f, 1.0f);
}


void NetSendObjectThrottle(const int con_num)
{
	return;
}
