#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleSetTitle(const int con_num, const char *arg)
{
	NetSendTitle(con_num);
}

void NetSendTitle(const int con_num)
{
	sw_legend_struct *legend = &sw_legend;
	char *sndbuf = (char *)malloc(
	    40 + 40 +
	    STRLEN(legend->title) +
	    80
	);

	/* Format SWEXTCMD_SETTITLE:
	 *
	 *	title
	 */
	sprintf(
	    sndbuf,
	    "%i %i %s\n",
	    CS_CODE_EXT,
	    SWEXTCMD_SETTITLE,
	    legend->title
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
