#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


void NetHandleSelectWeapon(
	const int con_num, const char *arg,
	const time_t cur_ms, const time_t cur_sec, const float tc
);
void NetSendSelectWeapon(const int con_num, const int obj_num);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


void NetHandleSelectWeapon(
	const int con_num, const char *arg,
	const time_t cur_ms, const time_t cur_sec, const float tc
)
{
	int obj_num = -1, sel_wep_num = -1;
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[con_num];
	const int con_obj_num = con->object_num;

	/* SWEXTCMD_SETWEAPON format:
	 *
	 *	obj_num sel_wep_num
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &obj_num, &sel_wep_num
	);

	if(obj_num != con_obj_num)
	    return;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];

	/* Make sure sel_wep_num is valid */
	if((sel_wep_num < 0) || (sel_wep_num >= SW_OBJ_WEAPONS_MAX))
	    return;
	if(sel_wep_num >= obj->total_weapons)
	    return;

	/* Set selected weapon */
	obj->selected_weapon = sel_wep_num;

	/* Set next object values update to now so it gets updated now */
	next.object_values = cur_ms;
}


void NetSendSelectWeapon(const int con_num, const int obj_num)
{
	return;
}
