#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h" 


void NetHandleWeaponValues(int con_num, const char *arg)
{
	int obj_num = -1, wep_num = -1;

	/* SWEXTCMD_STDWEPVALS format:
	 *
	 *      obj_num wep_num
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &obj_num, &wep_num
	);
	NetSendWeaponValues(con_num, obj_num, wep_num);
}
 
 
void NetSendWeaponValues(
	int con_num, int obj_num, int wep_num
)
{
	char *sndbuf;
	xsw_object_struct *obj;
	xsw_weapon_struct *wep;

	if(DBIsObjectGarbage(obj_num))
	    return;

	obj = xsw_object[obj_num];

	wep = ((wep_num >= 0) && (wep_num < obj->total_weapons)) ?
	    obj->weapons[wep_num] : NULL;
	if(wep == NULL)
	    return;

	sndbuf = (char *)malloc(
	    40 + 40 +
	    40 + 40 +
	    40 + 40 + 40 + 40 +
	    40 + 40 + 40 + 40 +
	    40 + 40 + 40 + 40 +
	    80
	);

	/* SWEXTCMD_STDWEPVALS format:
	 *
	 *	obj_num wep_num
	 *	ocs_code emission_type amount max
	 *	damage_hull damage_shields range create_power
	 *	delay last_used fire_sndref flags
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %i\
 %i %i %i %i\
 %.4f %.4f %ld %.4f\
 %ld %ld %i %lu\n",
	    CS_CODE_EXT,
	    SWEXTCMD_STDWEPVALS,
	    obj_num, wep_num,
	    wep->ocs_code, wep->emission_type, wep->amount, wep->max,
	    wep->damage_hull, wep->damage_shields, wep->range, wep->create_power,
	    wep->delay, wep->last_used, wep->fire_sndref,
	    (unsigned long)wep->flags
	);
	NetSendDataToConnection(con_num, sndbuf);
	free(sndbuf);
}
