#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? (int)strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)



void NetHandleWhoAmI(int condescriptor, const char *arg)
{
	NetSendWhoAmI(condescriptor);
}


void NetSendWhoAmI(int condescriptor)
{
	int obj_num;
	char *sndbuf;
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[condescriptor];

	/* Check if the connection is logged in with a valid object */
	obj_num = con->object_num;
	if(DBIsObjectGarbage(obj_num))
	{
            NetSendMessage(
                condescriptor,          
"Who am I information unknown, connection not logged in."
	    );
	    return;
	} 

	obj = xsw_object[obj_num];

	sndbuf = (char *)malloc(
	    40 + 40 + STRLEN(obj->name) + 80
	);

	/* CS_CODE_WHOAMI format:
	 *
	 *	obj_num;object_name
	 */
	sprintf(
	    sndbuf,
"%i %i;%s\n",
	    CS_CODE_WHOAMI,
	    obj_num, obj->name
	);
	NetSendDataToConnection(condescriptor, sndbuf);
	free(sndbuf);
}
