#include <stdio.h>
#include <stdlib.h>

#include "../include/unvfile.h"

#include "sysparm.h"
#include "swserv.h"


int OPMFileOpen(const char *path);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


/*
 *	Loads object parameter models from the specified file.
 */
int OPMFileOpen(const char *path)
{
	int total;
	sws_std_opm_struct *opm_ref = &sws_std_opm;

	/* Delete all existing OPMs */
	OPMDeleteAll();

	/* Load objects from file */
	total = total_opms;
	opm = UNVFileOpen(
	    path,
	    &total,
	    NULL,
	    NULL,	/* Client data */
	    NULL	/* Notify callback function */
	);
	total_opms = total;

	/* Get references to standard OPMs */
#define GET_OPM(_va_,_name_)	{		\
 *(_va_) = OPMGetByName((_name_), -1);		\
 if(*(_va_) < 0)				\
  fprintf(					\
   stderr,					\
"%s: Standard OPM `%s' not defined.\n",		\
   path, (_name_)				\
  );						\
}
	GET_OPM(
	    &opm_ref->debris_num,
	    SWS_DEF_DEBRIS_OPM_NAME
	);
	GET_OPM(
	    &opm_ref->debris_50_num, 
	    SWS_DEF_DEBRIS_50_OPM_NAME    
	);
	GET_OPM(
	    &opm_ref->debris_100_num,
	    SWS_DEF_DEBRIS_100_OPM_NAME
	);
	GET_OPM(
	    &opm_ref->debris_150_num, 
	    SWS_DEF_DEBRIS_150_OPM_NAME    
	);
	GET_OPM(
	    &opm_ref->debris_200_num,
	    SWS_DEF_DEBRIS_200_OPM_NAME
	);
	GET_OPM(
	    &opm_ref->debris_250_num, 
	    SWS_DEF_DEBRIS_250_OPM_NAME
	);
	GET_OPM(
	    &opm_ref->debris_300_num,
	    SWS_DEF_DEBRIS_300_OPM_NAME
	);
	GET_OPM(
	    &opm_ref->debris_starbase_num,
	    SWS_DEF_DEBRIS_STARBASE_OPM_NAME
	);
	GET_OPM(
	    &opm_ref->guest_num,
	    sysparm.guest_login_name
	);
	GET_OPM(
	    &opm_ref->new_player_num,
	    SWS_DEF_NEW_PLAYER_OPM_NAME
	);

#undef GET_OPM

	return(0);
}
