#ifndef WEAPONS_H
#define WEAPONS_H

#include "../include/objects.h"


extern int WeaponsFire(
	const int ocs_code,		/* OCS used to create the weapons fire */
	const int owner_obj_num,	/* Object to own the fired weapon object(s) */
	const int emission_type,
 	const float birth_x,		/* Location of fire (not offset) */
	const float birth_y,
	const float birth_heading,	/* Direction of fire */
	const float birth_pitch,
        const float damage_hull,
        const float damage_shields,
	const long range,		/* In screen units */
	const float freq,
	const sw_flags_t flags,		/* Any of SW_WEP_FLAG_* */
	const time_t cur_ms, const time_t cur_sec, const float tc
);

extern void WeaponsDisarmWeapon(const int wep_obj_num);

extern int WeaponsReclaimWeapon(
	const int obj_num,	/* Object picking up the weapon */
	const int wep_obj_num,	/* Weapon object to be picked up */
        const time_t cur_ms, const time_t cur_sec, const float tc
);


#endif	/* WEAPONS_H */
