#ifndef ABOUTDLG_H
#define ABOUTDLG_H

#include "../include/osw-x.h"
#include "../include/widget.h"
#include "uetypes.h"


/*
 *	Draw Amount Code:
 */
#define ABOUT_DLG_DRAW_AMOUNT_COMPLETE		0


/*
 *	About Dialog:
 */
struct _about_dlg_struct {

	bool_t		map_state,
			has_focus;
	int		x, y;
	unsigned int	width, height;

	win_t		toplevel;

	push_button_struct	ok_btn;

	/* Memory stats */
	unsigned long	        mem_used,
				mem_universe,
				mem_total;

};


extern about_dlg_struct *AboutDlgNew(void);
extern void AboutDlgDraw(about_dlg_struct *d, const int amount);
extern int AboutDlgManage(about_dlg_struct *d, event_t *event);
extern void AboutDlgMap(about_dlg_struct *d, win_t toplevel);
extern void AboutDlgUnmap(about_dlg_struct *d);
extern void AboutDlgDelete(about_dlg_struct *d);


#endif	/* ABOUTDLG_H */
