#ifndef CONFIG_H
#define CONFIG_H

#ifndef PREFIX
# define PREFIX				"/usr"
#endif


/*
 *	Default config file (path to user's home dir will be prepended):
 */
#define UE_DEF_CONFIG_FILE		".shipwars/unvedit.ini"

/*
 *	Default paths:
 */
#define UE_DEF_XSW_TOPLEVEL_DIR		PREFIX "/share/games/xshipwars"
#define UE_DEF_XSW_ETC_DIR		UE_DEF_XSW_TOPLEVEL_DIR "/etc"
#define UE_DEF_XSW_IMAGES_DIR		UE_DEF_XSW_TOPLEVEL_DIR "/images"
#define UE_DEF_XSW_SOUNDS_DIR		UE_DEF_XSW_TOPLEVEL_DIR "/sounds"
#define UE_DEF_SERVER_DIR		"/home/swserv"

/*
 *	Universe file name extension:
 */
#define UE_FILE_FORMAT_EXTENSION_IMGREFS	".isr"
#define UE_FILE_FORMAT_EXTENSION_MASK_IMGREFS	"*.isr"

#define UE_FILE_FORMAT_EXTENSION_OCS		".ocs"
#define UE_FILE_FORMAT_EXTENSION_MASK_OCS	"*.ocs"

#define UE_FILE_FORMAT_EXTENSION_OPM		".opm"
#define UE_FILE_FORMAT_EXTENSION_MASK_OPM	"*.opm"

#define UE_FILE_FORMAT_EXTENSION_SNDREFS	".ss"
#define UE_FILE_FORMAT_EXTENSION_MASK_SNDREFS	"*.ss"

#define UE_FILE_FORMAT_EXTENSION_TGA		".tga"
#define UE_FILE_FORMAT_EXTENSION_MASK_TGA	"*.tga"

#define UE_FILE_FORMAT_EXTENSION_UNV		".unv"
#define UE_FILE_FORMAT_EXTENSION_MASK_UNV	"*.unv"


/*
 *	Default data file names for this program:
 */
#define UE_FILE_ICON_UNVEDIT		"icon_unvedit_48x48.tga"
#define UE_FILE_ICON_UNVEDIT_LOGO	"unvedit_logo.tga"

#define UE_FILE_ICON_ABOUT		"icon_about_20x20.tga"
#define UE_FILE_ICON_CLOSE		"icon_close_20x20.tga"
#define UE_FILE_ICON_COPY		"icon_copy_20x20.tga"
#define UE_FILE_ICON_CUT		"icon_cut_20x20.tga"
#define UE_FILE_ICON_DELETE		"icon_delete_20x20.tga"
#define UE_FILE_ICON_EXPORT		"icon_export_20x20.tga"
#define UE_FILE_ICON_ECONOMY		"icon_economy_20x20.tga"
#define UE_FILE_ICON_IMPORT		"icon_import_20x20.tga"
#define UE_FILE_ICON_LEGEND		"icon_legend_20x20.tga"
#define UE_FILE_ICON_NEW		"icon_new_20x20.tga"
#define UE_FILE_ICON_NEW_OBJECT		"icon_new_object_20x20.tga"
#define UE_FILE_ICON_OBJECT_PROPERTIES	"icon_object_properties_20x20.tga"
#define UE_FILE_ICON_OPEN		"icon_open_20x20.tga"
#define UE_FILE_ICON_FILE_OPM		"icon_file_opm_20x20.tga"
#define UE_FILE_ICON_PASTE		"icon_paste_20x20.tga"
#define UE_FILE_ICON_REMODEL_OBJECT	"icon_remodel_object_20x20.tga"
#define UE_FILE_ICON_PRINT		"icon_print_20x20.tga"
#define UE_FILE_ICON_SAVE		"icon_save_20x20.tga"
#define UE_FILE_ICON_SAVE_AS		"icon_save_as_20x20.tga"
#define UE_FILE_ICON_SCREENSHOT		"icon_screenshot_20x20.tga"
#define UE_FILE_ICON_SELECT		"icon_select_20x20.tga"
#define UE_FILE_ICON_WEAPONS		"icon_weapons_20x20.tga"

#define UE_FILE_DEF_OCSN		"default.ocsn"
#define UE_FILE_DEF_IMGREFS		"default.isr"
#define UE_FILE_DEF_SNDREFS		"default.ss"


#endif	/* CONFIG_H */
