#ifndef ECOW_H
#define ECOW_H

#include "../include/objects.h"
#include "../include/osw-x.h"
#include "../include/widget.h"
#include "uetypes.h"


/*
 *	Economy Window:
 */
struct _ecow_struct {

	bool_t		map_state,
			has_focus;
	int		freeze_count;
	int		x, y;
	unsigned int	width, height;

	win_t		toplevel;

	uew_struct	*uew;
	int		obj_num;

	check_button_struct	opened_cb,
				buy_ok_cb,
				sell_ok_cb;

	prompt_struct	tax_general_prompt,
			tax_friend_prompt,
			tax_hostile_prompt;

	clist_struct	list;

	push_button_struct	create_prod_btn,
				delete_prod_btn;

	popup_list_struct	prod_ocs_pulist;
	prompt_struct	prod_buy_prompt,
			prod_sell_prompt,
			prod_amount_prompt,
			prod_max_prompt;

	push_button_struct	delete_obj_eco_btn,
				close_btn;

	bool_t		has_changes;
};


extern ecow_struct *EcoWNew(uew_struct *uew, const int obj_num);
extern void EcoWDraw(ecow_struct *ecow, const int amount);
extern void EcoWQueueDraw(ecow_struct *ecow, const int amount);
extern int EcoWManage(ecow_struct *ecow, event_t *event);
extern void EcoWMap(ecow_struct *ecow);
extern void EcoWMapValues(ecow_struct *ecow);
extern void EcoWUnmap(ecow_struct *ecow);
extern void EcoWDelete(ecow_struct *ecow);


#endif	/* ECOW_H */
