#ifndef PROPDLG_H
#define PROPDLG_H

#include "../include/objects.h"
#include "../include/osw-x.h"
#include "../include/widget.h"
#include "uetypes.h"


/*
 *	Draw Amounts:
 */
#define PROP_DLG_DRAW_COMPLETE		0
#define PROP_DLG_DRAW_OBJECT_DISPLAY	1


/*
 *	Properties Dialog:
 */
struct _prop_dlg_struct {

	bool_t		map_state,
			has_focus;
	int		freeze_count;
	int		x, y;
	unsigned int	width, height;

	win_t		toplevel;

	uew_struct	*uew;
	int		obj_num;

	prompt_struct	name_prompt,
			empire_prompt,
			uid_prompt, gid_prompt, owner_prompt,
			credits_prompt, rmu_prompt, rmu_max_prompt,
			size_prompt, velocity_max_prompt, visibility_prompt,
			hp_prompt, hp_max_prompt,
			power_prompt, power_max_prompt,
			power_purity_prompt, core_efficency_prompt,
			scanner_range_prompt, throttle_prompt,
			antimatter_prompt, antimatter_max_prompt,
			turn_rate_prompt,
			cloak_strength_prompt, cloak_refractory_int_prompt;

	label_struct		type_label,
				engine_label,
				shields_label,
				cloak_label;
	popup_list_struct	type_pulist,
				engine_pulist,
				shields_pulist,
				cloak_pulist;

	check_button_struct	vector_lights_cbtn,
				strobes_cbtn,
				external_lumination_cbtn;

	label_struct		follow_label,
				fire_label;
	check_button_struct	follow_friend_cbtn,
				follow_unknown_cbtn,
				follow_hostile_cbtn,
				fire_friend_cbtn,
				fire_unknown_cbtn,
				fire_hostile_cbtn;

	popup_list_struct	imgrefs_pulist;
	win_t		object_display;
	pixmap_t	object_display_buf;
	shared_image_t	*object_display_img;

	int		ani_frame,
			ani_total_frames;
	time_t		ani_int,
			ani_next;


	push_button_struct	ok_btn,
				apply_btn,
				cancel_btn;

	bool_t		has_changes;

};


extern prop_dlg_struct *PropDlgNew(uew_struct *uew, const int obj_num);
extern void PropDlgDraw(prop_dlg_struct *d, const int amount);
extern void PropDlgQueueDraw(prop_dlg_struct *d, const int amount);
extern int PropDlgManage(prop_dlg_struct *d, event_t *event);
extern void PropDlgMaintain(
	void *data, prop_dlg_struct *d,
	const time_t cur_ms, const time_t cur_sec, const float tc
);
extern void PropDlgUpdateWidgets(prop_dlg_struct *d);
extern void PropDlgMap(prop_dlg_struct *d);
extern void PropDlgMapValues(prop_dlg_struct *d);
extern void PropDlgUnmap(prop_dlg_struct *d);
extern void PropDlgDelete(prop_dlg_struct *d);


#endif	/* PROPDLG_H */

