#ifndef SNDREFS_H
#define SNDREFS_H

typedef struct _sndref_struct		sndref_struct;
#define SNDREF(p)			((sndref_struct *)(p))


/*
 *	SndRef:
 */
struct _sndref_struct {

	unsigned int	options;
	
	char		*path,		/* Path to the sound file */
			*name,
			*description;
};


#ifdef __cplusplus
extern "C" {
#endif


/* In sndrefs.cpp */
extern sndref_struct *SndRefGetPtr(
        sndref_struct **sndrefs_list, const int nsndrefs,
	const int sndref_num
);
extern sndref_struct *SndRefNew(void);
extern int SndRefNewExplicit(
        sndref_struct ***sndrefs_list, int *nsndrefs,
        const int sndref_num
);
extern void SndRefDelete(
        sndref_struct **sndrefs_list, const int nsndrefs,
	const int sndref_num
);
extern void SndRefDeleteAll(
        sndref_struct ***sndrefs_list, int *nsndrefs
);


/* In sndrefsfio.cpp */
extern int SndRefsFileOpen(
	sndref_struct ***sndrefs_list, int *nsndrefs,
	const char *path,
	char **audio_mode_rtn,
        void (*progress_cb)(void *, unsigned long, unsigned long),
        void *progress_data,
        void (*print_warning)(const char *s)
);


#ifdef __cplusplus
}
#endif

#endif	/* SNDREFS_H */
