#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/objects.h"
#include "../include/osw-x.h"
#include "../include/widget.h"

#include "uew.h"


void UEWObjectsListItemUpdateObjNum(
	uew_struct *uew, const int obj_num
);
void UEWObjectsListItemUpdateObjName(
	uew_struct *uew, const int obj_num
);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)


/*
 *	Updates the object number of the specified item.
 */
void UEWObjectsListItemUpdateObjNum(
	uew_struct *uew, const int obj_num
)
{
	char s[40];
	int row_num;
	clist_struct *clist;
	xsw_object_struct *obj;

	if(uew == NULL)
	    return;

	clist = &uew->objects_list;
	row_num = obj_num;
	obj = SW_OBJECT(CListRowGetData(clist, row_num));
	if(obj == NULL)
	    return;

	sprintf(s, "#%i", obj_num);
	CListSetItemText(clist, row_num, 0, s);
}

/*
 *	Updates the name of the object on the specified item.
 */
void UEWObjectsListItemUpdateObjName(
	uew_struct *uew, const int obj_num
)
{
	int row_num;
	clist_struct *clist;
	xsw_object_struct *obj;

	if(uew == NULL)
	    return;

	clist = &uew->objects_list;
	row_num = obj_num;
	obj = SW_OBJECT(CListRowGetData(clist, row_num));
	if(obj == NULL)
	    return;

	CListSetItemText(clist, row_num, 1, obj->name);
}
