#ifndef UHW_H
#define UHW_H

#include "../include/osw-x.h"
#include "../include/widget.h"
#include "../include/objects.h"
#include "uetypes.h"


/*
 *	Universe Header Window:
 */
struct _uhw_struct {

	bool_t		map_state,
			has_focus;
	int		x, y;
	unsigned int	width, height;

	uew_struct	*uew;

	win_t		toplevel;

	prompt_struct	title_prompt,
			ru_to_au_prompt,
			lost_found_owner_prompt,

			ocsn_file_prompt,
			imgrefs_file_prompt,
			sndrefs_file_prompt,

			player_start_pos_prompt,
			player_start_dir_prompt,

			guest_start_pos_prompt,
			guest_start_dir_prompt;

	push_button_struct	ocsn_file_btn,
				imgrefs_file_btn,
				sndrefs_file_btn;

	prompt_struct	antimatter_low_warning_prompt,
			asteroid_field_damage_int_prompt,
			asteroid_field_damage_rate_prompt,
			auto_destruct_damage_range_prompt,
			cloak_antimatter_rate_prompt,
			com_range_prompt,
			damage_control_rate_prompt,
			disarmed_weapon_lifespan_prompt,
			engine_antimatter_rate_prompt,
			no_antimatter_thrust_coeff_prompt,
			on_fire_hp_coeff_prompt,
			tractor_beam_antimatter_rate_prompt,
			tractor_beam_range_prompt,
			transporter_range_prompt;

	push_button_struct	ok_btn,
				apply_btn,
				cancel_btn;

	bool_t		has_changes;

};


/* uhw.cpp */
extern uhw_struct *UHWNew(uew_struct *uew);
extern void UHWDraw(uhw_struct *uhw, const int amount);
extern void UHWQueueDraw(uhw_struct *uhw, const int amount);
extern int UHWManage(uhw_struct *uhw, event_t *event);
extern void UHWMap(uhw_struct *uhw);
extern void UHWMapValues(uhw_struct *uhw);
extern void UHWUnmap(uhw_struct *uhw);
extern void UHWDelete(uhw_struct *uhw);


#endif	/* UHW_H */
