#ifndef WEPW_H
#define WEPW_H

#include "../include/objects.h"
#include "../include/osw-x.h"
#include "../include/widget.h"
#include "uetypes.h"


/*
 *	Weapons Window:
 */
struct _wepw_struct {

	bool_t		map_state,
			has_focus;
	int		freeze_count;
	int		x, y;
	unsigned int	width, height;

	win_t		toplevel;

	uew_struct	*uew;
	int		obj_num;

	clist_struct	list;

	push_button_struct	weapon_add_btn,
				weapon_remove_btn;

	popup_list_struct	ocs_pulist,
				emission_type_pulist;

	prompt_struct	amount_prompt,
			max_prompt,
			damage_hull_prompt,
			damage_shields_prompt,
			range_prompt,
			create_power_prompt,
			delay_prompt;

	label_struct	fire_sndref_label;
	popup_list_struct	fire_sndref_pulist;

	check_button_struct	no_lock_cb,
				fire_cloaked_cb,
				no_fire_sound_cb,
				fixed_cb,
				penetrate_shield_cb,
				destroyable_cb,
				smoke_trail_cb,
				smoke_puff_fired_cb,
				shockwave_hit_cb;

	push_button_struct	close_btn;

	bool_t		has_changes;
};


extern wepw_struct *WepWNew(uew_struct *uew, const int obj_num);
extern void WepWDraw(wepw_struct *wepw, const int amount);
extern void WepWQueueDraw(wepw_struct *wepw, const int amount);
extern int WepWManage(wepw_struct *wepw, event_t *event);
extern void WepWMap(wepw_struct *wepw);
extern void WepWMapValues(wepw_struct *wepw);
extern void WepWUnmap(wepw_struct *wepw);
extern void WepWDelete(wepw_struct *wepw);


#endif	/* WEPW_H */
